Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.tree.wrapper
Class SpaceStrippedNode

    java.lang.Object
      net.sf.saxon.tree.wrapper.AbstractVirtualNode
          net.sf.saxon.tree.wrapper.SpaceStrippedNode

All Implemented Interfaces:
  Source, PullEvent, Item<NodeInfo>, NodeInfo, ValueRepresentation<NodeInfo>, VirtualNode, WrappingFunction

Direct Known Subclasses:
  SpaceStrippedDocument

    public class SpaceStrippedNode

extends AbstractVirtualNode
implements WrappingFunction

A StrippedNode is a view of a node, in a virtual tree that has whitespace text nodes stripped from it. All operations on the node produce the same result as operations on the real underlying node, except that iterations over the axes take care to skip whitespace-only text nodes that are supposed to be stripped. Note that this class is only used in cases where a pre-built tree is supplied as the input to a transformation, and where the stylesheet does whitespace stripping; if a SAXSource or StreamSource is supplied, whitespace is stripped as the tree is built.

Field Summary

Fields inherited from class net.sf.saxon.tree.wrapper.AbstractVirtualNode
`docWrapper, node, parent`

Fields inherited from interface net.sf.saxon.om.NodeInfo
`ALL_NAMESPACES, IS_DTD_TYPE, IS_NILLED, LOCAL_NAMESPACES, NO_NAMESPACES`

Fields inherited from interface net.sf.saxon.om.ValueRepresentation
`EMPTY_VALUE_ARRAY`

Constructor Summary
`protected` | `SpaceStrippedNode()`
`protected` | `SpaceStrippedNode(NodeInfo node, SpaceStrippedNode parent)` This constructor is protected: nodes should be created using the makeWrapper factory method

Method Summary
`Value` | `atomize()` Get the typed value.
`int` | `compareOrder(NodeInfo other)` Determine the relative position of this node and another node, in document order.
`void` | `copy(Receiver out, int copyOptions, int locationId)` Copy this node to a given outputter (deep copy)
`NodeInfo` | `getParent()` Get the NodeInfo object representing the parent of this node
`CharSequence` | `getStringValueCS()` Get the value of the item as a CharSequence.
`boolean` | `isSameNodeInfo(NodeInfo other)` Determine whether this is the same node as another node.
`AxisIterator` | `iterateAxis(byte axisNumber)` Return an iteration over the nodes reached by the given axis from this node
`protected static SpaceStrippedNode` | `makeWrapper(NodeInfo node, SpaceStrippedDocument docWrapper, SpaceStrippedNode parent)` Factory method to wrap a node with a wrapper that implements the Saxon NodeInfo interface.
`VirtualNode` | `makeWrapper(NodeInfo node, VirtualNode parent)` Factory method to wrap a node within the same document as this node with a VirtualNode

Methods inherited from class net.sf.saxon.tree.wrapper.AbstractVirtualNode
`equals, generateId, getAttributeValue, getAttributeValue, getBaseURI, getColumnNumber, getConfiguration, getDeclaredNamespaces, getDisplayName, getDocumentNumber, getDocumentRoot, getFingerprint, getLineNumber, getLocalPart, getNameCode, getNamePool, getNodeKind, getPrefix, getRealNode, getRoot, getSchemaType, getStringValue, getSystemId, getTypeAnnotation, getTypedValue, getUnderlyingNode, getURI, hasChildNodes, hashCode, isId, isIdref, isNilled, iterateAxis, setSystemId`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### SpaceStrippedNode

    protected SpaceStrippedNode()

### SpaceStrippedNode

    protected SpaceStrippedNode(NodeInfo node,
                                SpaceStrippedNode parent)

  This constructor is protected: nodes should be created using the makeWrapper factory method

  Parameters:
    `node` - The node to be wrapped
    `parent` - The StrippedNode that wraps the parent of this node

Method Detail

### makeWrapper

    protected static SpaceStrippedNode makeWrapper(NodeInfo node,
                                                   SpaceStrippedDocument docWrapper,
                                                   SpaceStrippedNode parent)

  Factory method to wrap a node with a wrapper that implements the Saxon NodeInfo interface.

  Parameters:
    `node` - The underlying node
    `docWrapper` - The wrapper for the document node (must be supplied)
    `parent` - The wrapper for the parent of the node (null if unknown)
  Returns:
    The new wrapper for the supplied node

### makeWrapper

    public VirtualNode makeWrapper(NodeInfo node,
                                   VirtualNode parent)

  Factory method to wrap a node within the same document as this node with a VirtualNode

  Specified by:
    `makeWrapper` in interface `WrappingFunction`
  Parameters:
    `node` - The underlying node
    `parent` - The wrapper for the parent of the node (null if unknown)
  Returns:
    The new wrapper for the supplied node

### atomize

    public Value atomize()
                  throws XPathException

  Get the typed value. The result of this method will always be consistent with the method `Item.getTypedValue()`. However, this method is often more convenient and may be more efficient, especially in the common case where the value is expected to be a singleton.

  Specified by:
    `atomize` in interface `NodeInfo`
  Overrides:
    `atomize` in class `AbstractVirtualNode`
  Returns:
    the typed value. If requireSingleton is set to true, the result will always be an AtomicValue. In other cases it may be a Value representing a sequence whose items are atomic values.
  Throws:
    `XPathException` - if the node has no typed value, for example if it is an element node with element-only content
  Since:
    8.5

### isSameNodeInfo

    public boolean isSameNodeInfo(NodeInfo other)

  Determine whether this is the same node as another node.
  Note: a.isSameNode(b) if and only if generateId(a)==generateId(b)

  Specified by:
    `isSameNodeInfo` in interface `NodeInfo`
  Overrides:
    `isSameNodeInfo` in class `AbstractVirtualNode`
  Parameters:
    `other` - the node to be compared with this node
  Returns:
    true if this Node object and the supplied Node object represent the same node in the tree.

### compareOrder

    public int compareOrder(NodeInfo other)

  Determine the relative position of this node and another node, in document order. The other node will always be in the same document.

  Specified by:
    `compareOrder` in interface `NodeInfo`
  Overrides:
    `compareOrder` in class `AbstractVirtualNode`
  Parameters:
    `other` - The other node, whose position is to be compared with this node
  Returns:
    -1 if this node precedes the other node, +1 if it follows the other node, or 0 if they are the same node. (In this case, isSameNode() will always return true, and the two nodes will produce the same result for generateId())

### getStringValueCS

    public CharSequence getStringValueCS()

  Get the value of the item as a CharSequence. This is in some cases more efficient than the version of the method that returns a String.

  Specified by:
    `getStringValueCS` in interface `Item<NodeInfo>`
  Specified by:
    `getStringValueCS` in interface `ValueRepresentation<NodeInfo>`
  Overrides:
    `getStringValueCS` in class `AbstractVirtualNode`
  Returns:
    the string value of the item
  See Also:
    `Item.getStringValue()`

### getParent

    public NodeInfo getParent()

  Get the NodeInfo object representing the parent of this node

  Specified by:
    `getParent` in interface `NodeInfo`
  Returns:
    the parent of this node; null if this node has no parent

### iterateAxis

    public AxisIterator iterateAxis(byte axisNumber)

  Return an iteration over the nodes reached by the given axis from this node

  Specified by:
    `iterateAxis` in interface `NodeInfo`
  Parameters:
    `axisNumber` - the axis to be used
  Returns:
    a SequenceIterator that scans the nodes reached by the axis in turn.
  See Also:
    `Axis`

### copy

    public void copy(Receiver out,
                     int copyOptions,
                     int locationId)
              throws XPathException

  Copy this node to a given outputter (deep copy)

  Specified by:
    `copy` in interface `NodeInfo`
  Parameters:
    `out` - the Receiver to which the node should be copied. It is the caller's responsibility to ensure that this Receiver is open before the method is called (or that it is self-opening), and that it is closed after use.
    `copyOptions` - a selection of the options defined in `CopyOptions`
    `locationId` - If non-zero, identifies the location of the instruction that requested this copy. If zero, indicates that the location information
  Throws:
    `XPathException` - if any downstream error occurs

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.